#ifdef GL_ES
precision highp float;
#endif

uniform vec2 u_mouse;
uniform vec2 u_resolution;
uniform mat3 u_matrix_x;
uniform mat3 u_matrix_y;
uniform float u_scale;

uniform sampler2D u_tex0;
uniform vec2 u_tex0Resolution;

varying vec4 v_position;
varying vec4 v_color;
varying vec3 v_normal;
varying vec2 v_texcoord;

#define PI 3.141592653589793

void main (void) {
    float scale = u_scale;
    float aspect2 = u_resolution.y / u_resolution.x;
    vec2 rads = vec2(PI * 2., PI);
    vec2 pnt = (v_texcoord - .5) * vec2(scale, scale * aspect2);

    float x2y2 = pnt.x * pnt.x + pnt.y * pnt.y;
    vec3 sphere_pnt = vec3(2. * pnt, x2y2 - 1.) / (x2y2 + 1.);
    sphere_pnt=u_matrix_y*sphere_pnt;
    sphere_pnt=u_matrix_x*sphere_pnt;

    float r = length(sphere_pnt);
    float lon = atan(sphere_pnt.y, sphere_pnt.x);
    float lat = acos(sphere_pnt.z / r);

	vec2 st = gl_FragCoord.xy / u_resolution.xy;
    float aspect = u_resolution.x / u_resolution.y;
	gl_FragColor = texture2D(u_tex0, st);
    gl_FragColor = texture2D(u_tex0, vec2(lon, lat) / rads);
}
